function array(m)
	local array = {}
	for i = 1, m do
		array[i] = 0
	end
	return array
end

function string.split(t,b)
	local cmd = {}
	local match = "[^%s]+"
	if type(b) == "string" then match = "[^"..b.."]+" end
	for word in string.gmatch(t, match) do table.insert(cmd, word) end
	return cmd
end 

function hudtxt(id,color,text,x,y,align)
	if(color==COLOR_NORMAL or color==nil) then
		color=""
	end
	parse("hudtxt "..id.." \""..color..text.."\" "..x.." "..y.." "..align)
end

function hudtxt2(player,id,color,text,x,y,align)
	if(color==COLOR_NORMAL or color==nil) then
		color=""
	end
	parse("hudtxt2 "..player.." "..id.." \""..color..text.."\" "..x.." "..y.." "..align)
end

function clearhudtxt(id)
	parse("hudtxt "..id.." \"\" 0 0 0")
end

function clearhudtxt2(player,id)
	parse("hudtxt2 "..player.." "..id.." \"\" 0 0 0")
end

LEFT = 0
CENTER = 1
RIGHT = 2
COLOR_NORMAL = 0

parse('mp_building_limit "Teleporter Entrance" 0')
parse('mp_building_limit "Teleporter Exit" 0')
parse('sv_gamemode 3')
parse('mp_building_limit "Dispenser" 9999999')
parse('mp_building_limit "Supply" 0')
parse('mp_building_limit "Turret" 0')
parse('mp_building_limit "Gate Field" 0')
parse('mp_building_limit "Barbed Wire" 0')
parse('mp_building_limit "Wall I" 0')
parse('mp_building_limit "Wall II" 0')
parse('mp_building_limit "Wall III" 0')
rand=0
prevrand=0

addhook("always","mapthing")
function mapthing()
	mapn = string.split(map("name"))
	hudtxt(1,"255255255",""..mapn[1].." "..mapn[2].." "..mapn[3].."",3,10,0)
	hudtxt(2,"255255255",""..mapn[4].." "..mapn[5].."",3,22,0)
	parse('mp_infammo 0')
end

addhook("minute","tips")
function tips()
	hudtxt(3,"255255255","Tip:",0,135,0)
	clearhudtxt(4)
	clearhudtxt(5)
	clearhudtxt(6)
	if rand~=0 then
		prevrand=rand
	end
	rand=math.random(1,6)
	if rand==prevrand then
		rand=math.random(1,6)
	end
	if rand==1 then
		hudtxt(4,"255255255","If you're far away from your base,",0,150,0)
		hudtxt(5,"255255255","build a dispenser for ammo, health",0,162,0)
		hudtxt(6,"255255255","and money!",0,174,0)
	elseif rand==2 then
		hudtxt(4,"255255255","Remember that you mustn't be always",0,150,0)
		hudtxt(5,"255255255","the destroyer, you can block traffic",0,162,0)
		hudtxt(6,"255255255","with the shield!",0,174,0)
	elseif rand==3 then
		hudtxt(4,"255255255","If you see many turrets around the corner",0,150,0)
		hudtxt(5,"255255255","throw a grenade to lower their health",0,162,0)
		hudtxt(6,"255255255","without losing yours!",0,174,0)
	elseif rand==4 then
		hudtxt(4,"255255255","When your teammates wait for somebody to",0,150,0)
		hudtxt(5,"255255255","attack the turrets, then YOU should attack!",0,162,0)
	elseif rand==5 then
		hudtxt(4,"255255255","When coming to the end, try to stay alive",0,150,0)
		hudtxt(5,"255255255","as long as you can, because the turrets are",0,162,0)
		hudtxt(6,"255255255","becoming more powerful with every kill!!",0,174,0)
	else
		hudtxt(4,"255255255","Never ignore single turrets, they can be",0,150,0)
		hudtxt(5,"255255255","a threat for the other players!",0,162,0)
	end
end